<?php


namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Organization
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getOrganizationScore($minRevenue) {
        /*BUG ORACLE coloquei a tabela direto OM_PARAM_ORG, mas estava zerando o VRCNPJFATU... ai ficou assim*/
        $join = "LEFT JOIN (SELECT OPO.* FROM ORGANIZACAO O JOIN OM_PARAM_ORG OPO ON (O.NRORG = OPO.NRORG)) OPO ON (O.NRORG = OPO.NRORG)";
        $query = <<<SQL
      SELECT *
          FROM ( SELECT O.NRORG, O.NMRAZSOCIALORG, O.NMORGANIZACAO, O.PREPSTATUS, O.IDATIVO, CLI.NRPARCNEGOCIO,
                        O.IDTIPOINSCRORG, O.NRORGPRINCIPAL, O.PREPSTATUS AS ORGSTATUS, 
                        TO_NUMBER(NVL(OPO.VRCNPJFATU, 0)) AS VRCNPJFATU, TO_NUMBER(NVL(OPO.VRTOTALFATU, 0)) AS VRTOTALFATU,
                        DECODE(O.NRORGPRINCIPAL, NULL, 'P', 'S') AS IS_PRIMARY, O.IDALTNRSCORE,
                        DECODE(O.NRORGPRINCIPAL, NULL, O.IDORGSAAS, OM.IDORGSAAS) AS IDORGSAAS, NVL(O.IDALERTA, 'N') AS IDALERTA,
                        O.DSDIRETORCLIE, O.DSRESPTICLIE, O.CDOPERPADRINHO, O.CDOPERGERENTE, O.IDOPERGERPROJ,
                        OP1.NMOPERADOR AS NMOPERPADRINHO, OP2.NMOPERADOR AS NMOPERGERENTE, OPO.VROVERDUE, CLI.DTVALARQPERS, CLI.NRDIAVALPERS,
                        CASE WHEN (OPO.VROVERDUE > 0 )
                             THEN 'S' 
                             ELSE 'N'
                        END AS OVERDUE,
                        CASE WHEN (CLI.NRDIAVALPERS = 0 AND CLI.DTVALARQPERS IS NOT NULL )
                             THEN 'S'
                             ELSE 'N'
                        END AS CONTROL_PER,
                        CASE WHEN CLI.NRDIAVALPERS = 0
                             THEN CLI.DTVALARQPERS
                             ELSE null
                        END AS DATE_CONTROL_PER,
                        CASE WHEN O.NRSCORE > 100
                             THEN 100
                             WHEN O.NRSCORE < 1
                             THEN 1
                             WHEN O.NRSCORE IS NULL
                             THEN 1
                             ELSE O.NRSCORE
                         END AS NRSCORE,
                         CASE WHEN OPO.IDPERCPIMP = 'S'
                             THEN 'B'
                             WHEN TO_NUMBER(NVL(OPO.VRTOTALFATU, 0)) > TO_NUMBER($minRevenue)
                             THEN 'S'
                             ELSE 'N'
                         END AS IDPERCPIMP
                   FROM ORGANIZACAO O
             INNER JOIN CLIENTE CLI    ON (CLI.NRPARCNEGOCIO = O.NRPARCNEGOCIO AND CLI.IDCLIEATIV = 'S')
              LEFT JOIN ORGANIZACAO OM ON (O.NRORGPRINCIPAL = OM.NRORG)
              LEFT JOIN OPERADOR OP1   ON OP1.CDOPERADOR = O.CDOPERPADRINHO
              LEFT JOIN OPERADOR OP2   ON OP2.CDOPERADOR = O.CDOPERGERENTE
              $join
              LEFT JOIN (SELECT CLIE.CDCLIENTE,
                                CEIL(SUM(NVL(MED.VRMEDICAO, NVL(CARENCIA.VRTOTITEMCOMDESC, NEG.VRTOTITEMCOMDESC))) / 100000 * 100) AS VRTOTAL
                           FROM FCT_CONTRATO CONT
                          INNER JOIN FCT_NEGOCIACAOCONTRATO NEG
                             ON CONT.NRSEQCONTRATO = NEG.NRSEQCONTRATO
                          INNER JOIN CLIENTE CLIE
                             ON CONT.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO
                           LEFT JOIN FCT_MEDICAOFATURA MED
                             ON CONT.NRSEQCONTRATO = MED.NRSEQCONTRATO
                            AND MED.IDSITUACAO     IN ('3', '4')
                            AND TRUNC(SYSDATE) BETWEEN TRUNC(MED.DTINICOMPET) AND TRUNC(MED.DTFINCOMPET)
                           LEFT JOIN FCT_DESCPERIODONEGOCONT CARENCIA
                             ON NEG.NRNEGOCIACAOCONTRATO = CARENCIA.NRNEGOCIACAOCONTRATO
                            AND NRORDEMAPLICADESC        = (SELECT MIN(NRORDEMAPLICADESC)
                                                              FROM FCT_DESCPERIODONEGOCONT
                                                             WHERE NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                                                               AND TRUNC(SYSDATE)      <= TRUNC(DTFINALVALIDADEDESC))
                          WHERE TRUNC(NVL(CONT.DTFINVIGENCONT, CONT.DTFIMCONTRATO)) >= TRUNC(SYSDATE)
                            AND CONT.IDSITUACAOCONTRATO = 'A'
                            AND NEG.IDTPFATURA          IN ('A', 'X')
                            AND NEG.NRTIPOORCAMENTO     <> 37
                          GROUP BY CLIE.CDCLIENTE) VAL ON VAL.CDCLIENTE = CLI.CDCLIENTE)
         WHERE 1 = 1

SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
        // $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        // return ($result) ? $result : [];
    }
}
