<?php

namespace OrganizationsManagement\Service;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Repository\VersionRegistration as VersionRegistrationRepository;

class VersionRegistration
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var VersionRegistrationRepository
     */
    private $versionRegistrationRepository;

    /**
     * VersionRegistration constructor.
     * @param EntityManager $entityManager
     * @param VersionRegistrationRepository $versionRegistrationRepository
     */
    public function __construct(EntityManager $entityManager, VersionRegistrationRepository $versionRegistrationRepository)
    {
        $this->entityManager = $entityManager;
        $this->versionRegistrationRepository = $versionRegistrationRepository;
    }

    public function findVersionRegistration(): array
    {
        return $this->versionRegistrationRepository->findVersionRegistrationOnliWithSubject();
    }

    public function updateCell($data)
    {
        $params = array();
        for ($i = 0; $i < sizeof($data); $i++) {
            array_push($params, [
                $data[$i]['nmrVerObjBd'],
                $data[$i]['originalData']['CDPRODGRUP'],
                $data[$i]['originalData']['CDVERPRODUTO'],
                $data[$i]['originalData']['CDRELVERPROD'],
                $data[$i]['originalData']['CDPATCHVERPR']
            ]);
        }

        $this->versionRegistrationRepository->updateCell($params);
    }
}
