/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLAUSULA                                                 */
/* Tabela : CLAUSULA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CLAUSULA
BEFORE INSERT OR UPDATE OR DELETE
ON CLAUSULA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCLAU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCLAUSULA,0) <> NVL(:NEW.CDCLAUSULA,0)) OR
         (NVL(:OLD.NMCLAUSULA,0) <> NVL(:NEW.NMCLAUSULA,0)) OR
         (NVL(:OLD.CDNORMA,0)    <> NVL(:NEW.CDNORMA,0)) THEN
         :NEW.DTULTATUCLAU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CLAUSULA', '', 'CDNORMA='||:OLD.CDNORMA||';CDCLAUSULA='||:OLD.CDCLAUSULA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CLAUSULA MODIFY DTULTATUCLAU DEFAULT SYSDATE
/
