/******************************************************************************/
/* SITE - Sistemas Integrados TECNISA                                         */
/******************************************************************************/
/* Nome: 8654_VMNSTP_PrecoProduto                                             */
/*                                                                            */
/* Descrio:                                                                 */
/*  Retorna o preo do produto                                                */
/*                                                                            */
/* Criao:                                                                   */
/* 07/07/2003 - Luciana Correa                                                */
/******************************************************************************/
/* EXEC Preco_Produto ('9999','0000000113','0000000113','0000000113','01/04/2002','01/05/2002', '','','','','T','T','T','T', :A,:B,:C,:D) */
/* raise_application_error(-20501, '' , True);                                */
/* @C:\Web_405\Sql\End_Conv\Oracle\8654_VMNSTPO_PRECO_PRODUTO.SQL             */
/* DBMS_OUTPUT.PUT_LINE('INSERT INTO ITEMAPABASEV')                           */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE Preco_Produto
   (
    P_CDEQUIPPRO   IN  EQUIPAPROD.CDEQUIPPRO%TYPE   ,
    P_CDPRODUTO    IN  PRODUTO.CDPRODUTO%TYPE,
    P_DATAPRECO    IN  ITEMPRECO.DTINIVGPREC%TYPE,
    P_VRPRITEMMAP  OUT ITEMAPABASEV.VRPRITEMMAP%TYPE,
    P_VRPRITEMCMAP OUT ITEMAPABASEV.VRPRITEMMAP%TYPE,
    P_POSSUIPRECO  OUT VARCHAR2
    )
IS
    V_VRPRECO     ITEMAPABASEV.VRPRITEMMAP%TYPE;
    V_VRPRECOCL   ITEMAPABASEV.VRPRITEMMAP%TYPE;
    V_EXISTE_PROD NUMBER;
BEGIN
   P_VRPRITEMMAP  := 0;
   P_VRPRITEMCMAP := 0;
   P_POSSUIPRECO  := 'S';

   V_VRPRECO   := 0;
   V_VRPRECOCL := 0;

   SELECT COUNT(*)
   INTO   V_EXISTE_PROD
   FROM   ITEQUIPPRO
   WHERE  CDEQUIPPRO   = P_CDEQUIPPRO
     AND  CDPRODUTO    = P_CDPRODUTO
     AND  DTINVIGCNFEP = (SELECT MAX(DTINVIGCNFEP)
                          FROM   CONFEQUIPPRO
                          WHERE  CDEQUIPPRO    = P_CDEQUIPPRO
                            AND  DTINVIGCNFEP <= P_DATAPRECO);

   IF V_EXISTE_PROD > 0 THEN
      SELECT NVL(MAX(VRPREPITEM),0),NVL(MAX(VRPREPITEMCL),0)
      INTO   V_VRPRECO, V_VRPRECOCL
      FROM   ITEQUIPPRO
      WHERE  CDEQUIPPRO   = P_CDEQUIPPRO       AND
             CDPRODUTO    = P_CDPRODUTO        AND
             DTINVIGCNFEP = (SELECT MAX(DTINVIGCNFEP)
                             FROM   CONFEQUIPPRO
                             WHERE  CDEQUIPPRO    = P_CDEQUIPPRO
                               AND  DTINVIGCNFEP <= P_DATAPRECO);
   END IF;

   IF V_VRPRECO > 0 THEN
      P_VRPRITEMMAP  := V_VRPRECO;
      P_VRPRITEMCMAP := V_VRPRECOCL;
   ELSE
      SELECT NVL(MAX(I.VRPRECITEM),0),NVL(MAX(I.VRPRECITEMCL),0)
      INTO   V_VRPRECO, V_VRPRECOCL
      FROM   ITEMPRECO I, EQUIPAPROD E
      WHERE  E.CDEQUIPPRO   = P_CDEQUIPPRO
        AND  I.CDPRODUTO    = P_CDPRODUTO
        AND  I.CDFILIAL     = E.CDFITABEPREC
        AND  I.CDTABEPREC   = E.CDTABEPREC
        AND  I.DTINIVGPREC  = (SELECT MAX(TA.DTINIVGPREC)
                               FROM  TABEVEND TA
                               WHERE TA.CDFILIAL     = E.CDFITABEPREC
                                 AND TA.CDTABEPREC   = E.CDTABEPREC
                                 AND P_DATAPRECO  BETWEEN TA.DTINIVGPREC AND TA.DTFINVGPREC);
      P_VRPRITEMMAP  := V_VRPRECO;
      P_VRPRITEMCMAP := V_VRPRECOCL;

   END IF;

   IF (V_VRPRECO <= 0) AND (V_VRPRECOCL <= 0) THEN
      P_POSSUIPRECO := 'N';  /* EXISTE PRODUTO SEM PREO OU COM PREO ZERO.*/
   END IF;

END;
/
