IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'PRXLOTEPROD'  and
            type = 'P'              and
            u.uid = o.uid           and
            u.name = USER)
  DROP PROCEDURE PRXLOTEPROD
  GO

CREATE PROCEDURE PRXLOTEPROD
   @P_CDFILIAL       VARCHAR(10),
   @P_DTVALILOTE     DATETIME,
   @P_CDPRODUTO      VARCHAR(10),
   @P_RESULT         VARCHAR(20) OUTPUT
AS

   DECLARE @V_STNUMLOTE    VARCHAR(50);
   DECLARE @V_STSEQLOTE    VARCHAR(50);
   DECLARE @V_CDPRODINTE   VARCHAR(20);
   DECLARE @V_STNUMERO     VARCHAR(20);
   DECLARE @V_INAJUSTA     INT;
   DECLARE @V_IDENTRSEQ    VARCHAR(1);     /* Gera lote sequencial - entrada */
   DECLARE @V_STORDELOTE   VARCHAR(50);   /* Ordenao do Lote */
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_CDORDENALOTE VARCHAR(20);
   DECLARE @V_COUNT        INT;
   DECLARE @V_NRTAM        INT;
   DECLARE @V_NRTAMSEQ     INT;
   DECLARE @V_STDS         VARCHAR(20);
   DECLARE @V_STDSSEQLOTE  VARCHAR(50);
   DECLARE @V_CONTADOR     VARCHAR(20);
   DECLARE @V_STORDENALOTE VARCHAR(20);
   DECLARE @V_STATLOTE     VARCHAR(1);
   DECLARE @V_SEQULTLOTE   VARCHAR(10);
   DECLARE @V_TAM          INT;
   DECLARE @V_TAMAUX       INT;
   DECLARE @V_CDEXT        INT;
   DECLARE @V_ANO4         INT;
   DECLARE @V_ANO2         INT;
   DECLARE @V_MES          INT;
   DECLARE @V_DIA          INT;
   DECLARE @V_SEQ          INT;
   DECLARE @V_FIL          INT;
   DECLARE @V_TAMSEQ       INT;
   DECLARE @V_TAMCDEXT     INT;
   DECLARE @V_TCDEXT       VARCHAR(1);
   DECLARE @V_TANO4        VARCHAR(1);
   DECLARE @V_TANO2        VARCHAR(1);
   DECLARE @V_TMES         VARCHAR(1);
   DECLARE @V_TDIA         VARCHAR(1);
   DECLARE @V_TSEQ         VARCHAR(1);
   DECLARE @V_TFIL         VARCHAR(1);
   DECLARE @V_EANO4        VARCHAR(4);
   DECLARE @V_EANO2        VARCHAR(2);
   DECLARE @V_EMES         VARCHAR(2);
   DECLARE @V_EDIA         VARCHAR(2);

BEGIN
   SET @V_COUNT        = 0;
   SET @V_NRLOTEESTQ   = NULL;
   SET @V_SEQULTLOTE   = NULL;
   SET @V_TAM = 1;
   SET @V_TAMAUX = 1;
   SET @V_TCDEXT = 'T';
   SET @V_TANO4  = 'T';
   SET @V_TANO2  = 'T';
   SET @V_TMES   = 'T';
   SET @V_TDIA   = 'T';
   SET @V_TSEQ   = 'T';
   SET @V_TFIL   = 'T';

   SELECT @V_STNUMLOTE = MAX(DSNUMELOTEPR),  @V_STSEQLOTE  = MAX(DSSEQULOTEPR),
          @V_IDENTRSEQ = MAX(IDENTRSEQLOTE), @V_STORDELOTE = MAX(DSORDENALOTE)
   FROM PARAMAN M, PARAMFILIAL F
   WHERE (M.CDFILIAL  = @P_CDFILIAL)  AND
         (M.CDFILIAL  = F.CDFILIAL)  AND
         (CDPARAMAN   = '1');

   IF NOT @P_CDPRODUTO IS NULL BEGIN
      SELECT
         @V_CDPRODINTE = MAX(ISNULL(CDPRODINTE,''))
      FROM
         PRODUTO
      WHERE
         (CDPRODUTO = @P_CDPRODUTO);
   END;

   SET @V_STDSSEQLOTE = @V_STORDELOTE;


   WHILE (@V_TAMAUX < LEN(@V_STNUMLOTE)) BEGIN
      IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX, 1) = '[' BEGIN
         IF (SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 3) = 'MES') BEGIN

            IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
               SET @V_MES = @V_TAM+1;
            ELSE
               SET @V_MES = @V_TAM;

            /*SET @V_MES = @V_TAM;*/
            SET @V_TAM = @V_MES+2;
            SET @V_TMES = '';
            IF (CHARINDEX('MES', @V_STSEQLOTE) = 0) BEGIN
               SET @V_EMES = '12';
            END;
         END;

         IF (SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 3) = 'DIA') BEGIN

            IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
               SET @V_DIA = @V_TAM+1;
            ELSE
               SET @V_DIA = @V_TAM;

           /*SET @V_DIA = @V_TAM;*/
           SET @V_TAM = @V_DIA+2;
           SET @V_TDIA = '';
           IF (CHARINDEX('DIA', @V_STSEQLOTE) = 0) BEGIN
              SET @V_EDIA = '31';
           END;
         END;

         IF (SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 3) = 'ANO') BEGIN
            IF SUBSTRING(@V_STNUMLOTE, CHARINDEX('ANO', @V_STNUMLOTE)+3, 1) = '2' BEGIN

               IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
                  SET @V_ANO2 = @V_TAM+1;
               ELSE
                  SET @V_ANO2 = @V_TAM;

               /*SET @V_ANO2 = @V_TAM;*/
               SET @V_TAM  = @V_ANO2+2;
               SET @V_TANO2 = '';
               IF (CHARINDEX('ANO', @V_STSEQLOTE) = 0) BEGIN
                  SET @V_EANO2 = RIGHT(CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),2);
               END;
            END;
            ELSE BEGIN

               IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
                  SET @V_ANO4 = @V_TAM+1;
               ELSE
                  SET @V_ANO4 = @V_TAM;

               /*SET @V_ANO4 = @V_TAM;*/
               SET @V_TAM  = @V_ANO4+4;
               SET @V_TANO4 = '';
               IF (CHARINDEX('ANO', @V_STSEQLOTE) = 0) BEGIN
                  SET @V_EANO4 = YEAR(@P_DTVALILOTE);
               END;
            END;
         END;

         IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 3) = 'SEQ' BEGIN

            IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
               SET @V_SEQ = @V_TAM+1;
            ELSE
               SET @V_SEQ = @V_TAM;

            /*SET @V_SEQ = @V_TAM;*/
            SET @V_TAMSEQ = CONVERT(INT, (SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+4, 1)));
            SET @V_TAM = @V_TAM + @V_TAMSEQ;
            SET @V_TSEQ = '';
         END;

         IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 4) = 'FIL' BEGIN

            IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
               SET @V_FIL = @V_TAM+1;
            ELSE
               SET @V_FIL = @V_TAM;

            /*SET @V_FIL = @V_TAM;*/
            SET @V_TAM = @V_FIL + 4;
            SET @V_TFIL = '';
         END;

         IF (SUBSTRING(@V_STNUMLOTE, @V_TAMAUX+1, 3) = 'CDE') BEGIN
/*            SET @V_CDEXT = @V_TAM;*/
            SET @V_TAMCDEXT = ISNULL(LEN(@V_CDPRODINTE),0);
            IF (@V_TAMCDEXT > 0) BEGIN

               IF SUBSTRING(@V_STNUMLOTE, @V_TAMAUX-1, 1) IN( '-', '.', '/')
                  SET @V_CDEXT = @V_TAM+1;
               ELSE
                  SET @V_CDEXT = @V_TAM;

               SET @V_TAM = @V_CDEXT + LEN(@V_CDPRODINTE);

               IF (CHARINDEX('CDEXT', @V_STSEQLOTE) > 0) BEGIN
                  SET @V_TCDEXT = '';
               END;
            ELSE
               IF @V_TAM = 1
                  SET @V_TAM = 0;
            END;
         END;
      END;
      SET @V_TAMAUX = @V_TAMAUX + 1;
   END;

   SET @V_TAM = @V_TAM - 1;

   SELECT
         @V_SEQULTLOTE = MAX(SUBSTRING( NRLOTEESTQ, @V_SEQ, @V_TAMSEQ  )), @V_NRLOTEESTQ = MAX(NRLOTEESTQ)
   FROM LOTE
   WHERE
      ((SUBSTRING( NRLOTEESTQ, @V_CDEXT, LEN(@V_CDPRODINTE)) = @V_CDPRODINTE) OR (@V_TCDEXT = 'T'))  AND
      ((RIGHT(CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_ANO2, 2)) OR (@V_TANO2 = 'T') OR (@V_EANO2 >= SUBSTRING( NRLOTEESTQ, @V_ANO2, 2))) AND
      ((RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4) = SUBSTRING( NRLOTEESTQ, @V_ANO4, 4)) OR (@V_TANO4 = 'T') OR (@V_EANO4 >= SUBSTRING( NRLOTEESTQ, @V_ANO4, 4))) AND
      ((RIGHT('00'+CONVERT(VARCHAR, MONTH(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_MES, 2)) OR (@V_TMES = 'T') OR (@V_EMES >= SUBSTRING( NRLOTEESTQ, @V_MES, 2))) AND
      ((RIGHT('00'+CONVERT(VARCHAR, DAY(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_DIA, 2)) OR (@V_TDIA = 'T') OR (@V_EDIA >= SUBSTRING( NRLOTEESTQ, @V_DIA, 2))) AND
      ((SUBSTRING( NRLOTEESTQ, @V_FIL, 4) = @P_CDFILIAL) OR (@V_TFIL = 'T'))  AND
      ((CDPRODUTO = @P_CDPRODUTO) OR (@V_TCDEXT = 'T')) AND
      ((LEN(NRLOTEESTQ) = @V_TAM-1)) AND
      CDFILIAL = @P_CDFILIAL AND
      SUBSTRING( NRLOTEESTQ, @V_SEQ, @V_TAMSEQ  )= (
                                                            SELECT
                                                                MAX(SUBSTRING( NRLOTEESTQ, @V_SEQ, @V_TAMSEQ  ))
                                                            FROM LOTE
                                                            WHERE
                                                               ((SUBSTRING( NRLOTEESTQ, @V_CDEXT, LEN(@V_CDPRODINTE)) = @V_CDPRODINTE) OR (@V_TCDEXT = 'T'))  AND
                                                               ((RIGHT(CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_ANO2, 2))
                                                                OR (@V_TANO2 = 'T') OR (@V_EANO2 >= SUBSTRING( NRLOTEESTQ, @V_ANO2, 2))) AND
                                                               ((RIGHT('00'+CONVERT(VARCHAR, DAY(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_DIA, 2))
                                                                OR (@V_TDIA = 'T') OR (@V_EDIA >= SUBSTRING( NRLOTEESTQ, @V_DIA, 2))) AND
                                                               ((RIGHT('00'+CONVERT(VARCHAR, MONTH(@P_DTVALILOTE)),2) = SUBSTRING( NRLOTEESTQ, @V_MES, 2))
                                                                OR (@V_TMES = 'T') OR (@V_EMES >= SUBSTRING( NRLOTEESTQ, @V_MES, 2))) AND
                                                               ((RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4) = SUBSTRING( NRLOTEESTQ, @V_ANO4, 4))
                                                                OR (@V_TANO4 = 'T') OR (@V_EANO4 >= SUBSTRING( NRLOTEESTQ, @V_ANO4, 4))) AND
                                                               ((SUBSTRING( NRLOTEESTQ, @V_FIL, 4) = @P_CDFILIAL) OR (@V_TFIL = 'T'))  AND
                                                               ((LEN(NRLOTEESTQ) = @V_TAM-1)) AND
                                                               ((CDPRODUTO = @P_CDPRODUTO) OR (@V_TCDEXT = 'T')) AND
                                                               CDFILIAL  = @P_CDFILIAL );

/*Pesquisa se o ltimo lote criado possui OP ou Entrada */
   IF NOT (@V_NRLOTEESTQ IS NULL) BEGIN
      SELECT @V_COUNT = COUNT(*)
      FROM(SELECT NRLOTEESTQ
           FROM ITLANCTOEST
           WHERE
              CDFILIMOVI  = @P_CDFILIAL     AND
              ISNULL( CDPRODMOVI, CDPRODUTO) = @P_CDPRODUTO    AND
              NRLOTEESTQ  = @V_NRLOTEESTQ
           UNION ALL
           SELECT NRLOTEESTQ
           FROM ORDPRODUCAO
           WHERE
              CDFILIAL    = @P_CDFILIAL    AND
              NRLOTEESTQ  = @V_NRLOTEESTQ   AND
              CDPRODUTO   = @P_CDPRODUTO)A;
   END;
/*Verifica se o ultimo lote est encerrado */
   IF NOT (@V_NRLOTEESTQ IS NULL) BEGIN
      SELECT @V_STATLOTE = IDSTATLOTE
        FROM LOTE
       WHERE
            CDFILIAL    = @P_CDFILIAL    AND
            NRLOTEESTQ  = @V_NRLOTEESTQ   AND
            CDPRODUTO   = @P_CDPRODUTO;
   END;

   IF (@V_STATLOTE IS NULL) OR (@V_STATLOTE = '') BEGIN
      SET @V_STATLOTE = 'E';
   END;

   IF @V_STATLOTE = 'E' BEGIN
      SET @V_COUNT = '1';
   END;



   /* SE POSSUIR LOTE E NO ESTIVER RETORNA O ULTIMO LOTE */
   IF (NOT @V_NRLOTEESTQ IS NULL) AND (@V_IDENTRSEQ = 'S')AND (@V_COUNT = 0) BEGIN
      SET @P_RESULT = SUBSTRING(@V_NRLOTEESTQ, 1, 20);
   END;
   ELSE BEGIN
/*Busca codigo externo do produto */

      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[ANO]'   , RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4));
      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[ANO2]'  , RIGHT('00'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),2));
      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[ANO4]'  , RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4));
      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[MES]'   , RIGHT('00'+CONVERT(VARCHAR, MONTH(@P_DTVALILOTE)),2));
      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[DIA]'   , RIGHT('00'+CONVERT(VARCHAR, DAY(@P_DTVALILOTE)),2));
      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[FIL]'   , @P_CDFILIAL);
/*      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[CDEXT]' , @V_CDPRODINTE);}*/

      IF LEN(@V_CDPRODINTE) >0
         SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[CDEXT]',@V_CDPRODINTE);
      ELSE
         IF (CHARINDEX('[CDEXT]-',@V_STNUMLOTE)=1)
            SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[CDEXT]-', '');
         ELSE
            IF (CHARINDEX('[CDEXT]/',@V_STNUMLOTE)=1)
               SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[CDEXT]/', '');
            ELSE
               IF (CHARINDEX('[CDEXT].',@V_STNUMLOTE)=1)
                   SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[CDEXT].', '');
               ELSE
                  IF (CHARINDEX('-[CDEXT]',@V_STNUMLOTE)>0)
                      SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '-[CDEXT]', '');
                  ELSE
                     IF (CHARINDEX('/[CDEXT]',@V_STNUMLOTE)>0)
                        SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '/[CDEXT]', '');
                     ELSE
                        IF (CHARINDEX('.[CDEXT]',@V_STNUMLOTE)>0)
                           SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '.[CDEXT]', '');


      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[ANO]'  , RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4));
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[ANO2]' , RIGHT('00'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),2));
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[ANO4]' , RIGHT('0000'+CONVERT(VARCHAR, YEAR(@P_DTVALILOTE)),4));
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[MES]'  , RIGHT('00'+CONVERT(VARCHAR, MONTH(@P_DTVALILOTE)),2));
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[DIA]'  , RIGHT('00'+CONVERT(VARCHAR, DAY(@P_DTVALILOTE)),2));
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[FIL]'  , @P_CDFILIAL);
      SET @V_STSEQLOTE = Replace(@V_STSEQLOTE, '[CDEXT]', @V_CDPRODINTE);

      SELECT @V_STDS = NRSEQUENCIAL
        FROM
            NOVOCODIGO
       WHERE
            CDCONTADOR  = @V_STSEQLOTE;
      IF (@V_STDS IS NULL) OR (@V_STDS = '') BEGIN
         SET @V_STDS = '000';
      END;


/* VERIFICA SE O SEQUENCIAL DO LOTE ESTA IGUAL AO SEQUENCIAL DO ULTIMO LOTE */
     IF CONVERT(INT, (@V_STDS)) <> CONVERT(INT, ( ISNULL(@V_SEQULTLOTE,'0'))) BEGIN
         IF @V_SEQULTLOTE IS NULL BEGIN
            SET @V_SEQULTLOTE = '0';
         END;
         UPDATE NOVOCODIGO
         SET NRSEQUENCIAL = RIGHT(REPLICATE('0',20)+@V_SEQULTLOTE,20)
         WHERE
            CDCONTADOR = @V_STSEQLOTE;
      END;

      IF CHARINDEX('[SEQ]', @V_STNUMLOTE) > 0 BEGIN
         SET @V_INAJUSTA  = 10;
         EXEC NOVO_CODIGO_SC @V_STSEQLOTE, @V_STNUMERO OUTPUT, 1;
         SET @V_STNUMERO  = SUBSTRING(@V_STNUMERO,21-@V_INAJUSTA,@V_INAJUSTA);
         SET @V_STNUMLOTE = Replace(@V_STNUMLOTE, '[SEQ]', @V_STNUMERO);
      END;
      ELSE IF CHARINDEX('[SEQ', @V_STNUMLOTE) > 0 BEGIN
         SET @V_INAJUSTA  = CONVERT(INT, (SUBSTRING(@V_STNUMLOTE, CHARINDEX('[SEQ', @V_STNUMLOTE) + 4, 1)));
         EXEC NOVO_CODIGO_SC @V_STSEQLOTE, @V_STNUMERO OUTPUT, 1;

         SET @V_STNUMERO  = SUBSTRING(@V_STNUMERO,21-@V_INAJUSTA,@V_INAJUSTA);
         SET @V_STNUMLOTE = REPLACE(@V_STNUMLOTE, '[SEQ'+CONVERT(VARCHAR, (@V_INAJUSTA))+']', @V_STNUMERO);
      END;

      SET @P_RESULT = SUBSTRING(@V_STNUMLOTE, 1, 20);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'PRXLOTEPROD','5.07.010';
GO
